# all files / ol/layer/ vectortilelayer.js

100% Statements 21/21
50% Branches 3/6
100% Functions 5/5
100% Lines 21/21

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    891×

    1×
    1×

    1×

    1×
    8×

    8×

    8×
    8×
    8×

    8×
    8×

    1×

    1×
    4×

    1×
    4×

    1×
    8×

    1×
    8×

     goog.provide('ol.layer.VectorTile');

    goog.require('ol.layer.Vector');
    goog.require('ol.object');

    /**
     * @enum {string}
     */
    ol.layer.VectorTileProperty = {
      PRELOAD: 'preload',
      USE_INTERIM_TILES_ON_ERROR: 'useInterimTilesOnError'
    };

    /**
     * @classdesc
     * Layer for vector tile data that is rendered client-side.
     * Note that any property set in the options is set as a {@link ol.Object}
     * property on the layer object; for example, setting `title: 'My Title'` in the
     * options means that `title` is observable, and has get/set accessors.
     *
     * @constructor
     * @extends {ol.layer.Vector}
     * @param {olx.layer.VectorTileOptions=} opt_options Options.
     * @api
     */
    ol.layer.VectorTile = function(opt_options) {
      var options = opt_options ? opt_options : {};

      var baseOptions = ol.object.assign({}, options);

      delete baseOptions.preload;
      delete baseOptions.useInterimTilesOnError;
      goog.base(this,  /** @type {olx.layer.VectorOptions} */ (baseOptions));

      this.setPreload(options.preload ? options.preload : 0);
      this.setUseInterimTilesOnError(options.useInterimTilesOnError ?
          options.useInterimTilesOnError : true);

    };
    goog.inherits(ol.layer.VectorTile, ol.layer.Vector);

    /**
     * Return the level as number to which we will preload tiles up to.
     * @return {number} The level to preload tiles up to.
     * @observable
     * @api
     */
    ol.layer.VectorTile.prototype.getPreload = function() {
      return /** @type {number} */ (this.get(ol.layer.VectorTileProperty.PRELOAD));
    };

    /**
     * Whether we use interim tiles on error.
     * @return {boolean} Use interim tiles on error.
     * @observable
     * @api
     */
    ol.layer.VectorTile.prototype.getUseInterimTilesOnError = function() {
      return /** @type {boolean} */ (
          this.get(ol.layer.VectorTileProperty.USE_INTERIM_TILES_ON_ERROR));
    };

    /**
     * Set the level as number to which we will preload tiles up to.
     * @param {number} preload The level to preload tiles up to.
     * @observable
     * @api
     */
    ol.layer.VectorTile.prototype.setPreload = function(preload) {
      this.set(ol.layer.TileProperty.PRELOAD, preload);
    };

    /**
     * Set whether we use interim tiles on error.
     * @param {boolean} useInterimTilesOnError Use interim tiles on error.
     * @observable
     * @api
     */
    ol.layer.VectorTile.prototype.setUseInterimTilesOnError = function(useInterimTilesOnError) {
      this.set(
          ol.layer.TileProperty.USE_INTERIM_TILES_ON_ERROR, useInterimTilesOnError);
    };